﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XCE_NullException
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
          
            
            MyVM myViewModel = new MyVM();
            this.DataContext = myViewModel;
        }
    }


    class MyVM : INotifyPropertyChanged
    {

        public MyVM()
        {
            Employess = new ObservableCollection<Employee>();


            Employess.Add(new Employee() { EmpId = 1});
            Employess.Add(new Employee() { EmpId = 2 });
            Employess.Add(new Employee() { EmpId = 3});
            Employess.Add(new Employee() { EmpId = 4});
        }



        private ObservableCollection<Employee> _Employess;

        public ObservableCollection<Employee> Employess
        {
            get { return _Employess; }
            set { _Employess = value; OnPropertyChanged("Employess"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
    public class Employee : INotifyPropertyChanged
    {
        private int _empId;


        public int EmpId
        {
            get
            {
                return this._empId;
            }
            set
            {
                if (this._empId != value)
                {
                    this._empId = value;
                    this.OnPropertyChanged("EmpId");
                }
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;
        protected void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        
    }
}
